// 
// File:   regulate.cc
// Author: cteam59
//
// Created on November 13, 2011, 10:22 AM
//

#include <stdlib.h>
#include <vector>
#include <iostream>

using namespace std;

struct cable{
       int to;
       int own;
};

//
// 
//
int main(int argc, char** argv) {
    vector<cable> conected[8001];
    vector<int> kolejka;
    int n,m,c,t;
    int fr,to,ow;
    int powt, pos, now, test=0;
    int spr[8001];
    bool find= false, redunt;
    cable actual;
    for(int i=0; i<8001; i++)
            spr[i]=0;
    while(1)
    {
        //Kolejny zestaw testowy - warunek konca, czyszczenie wektorow
        scanf("%d %d %d %d",&n,&m, &c,&t);
        if(n==0 && m==0 && c==0 && t==0)
            break;
        for(int i=0; i<n+1; i++)
            conected[i].clear();        
        

        //Wypelnienie grafu polaczonych serwerow
        for(int i=0; i<m;i++)
        {
            scanf("%d %d %d",&fr,&to,&ow);
            actual.to = to;
            actual.own = ow;
            conected[fr].push_back(actual);
            actual.to = fr;
            conected[to].push_back(actual);
        }
        //analiza transakcji
        for(int i=0;i<t;i++)
        {
            scanf("%d %d %d",&fr, &to, &ow);
            find = false;
            for(unsigned int j=0;j<conected[fr].size();j++)
            {
                if(conected[fr][j].to==to)
                {
                    find = true;
                    if(conected[fr][j].own==ow)
                        printf("Alredy owned.\n");
                    else {
                        //PRZEJSCIE PO GRAFIE, SZUKANIE CYKLI
                        redunt =false;
                        test=test+1;
                        kolejka.clear();
                        kolejka.push_back(to);
                        while(!kolejka.empty())
                        {
                            now = kolejka.back();
                            kolejka.pop_back();
                            for(unsigned int k=0; k<conected[now].size();k++)
                            {
                                if(conected[now][k].own==ow)
                                {
                                        if(conected[now][k].to==fr)
                                        {
                                            printf("Forbidden: redundant.\n");
                                            redunt=true;
                                            break;
                                        }
                                        if(spr[(conected[now][k].to)]!=test)
                                        {
                                            kolejka.push_back(conected[now][k].to);
                                        }
                                }
                            }
                        }
                        if(redunt==true)
                            break;
                        //POZOSTALE WARUNKI
                        powt = 0;
                        for(unsigned int k=0; k<conected[fr].size();k++)
                        {
                            if(conected[fr][k].own==ow)
                                powt++;
                        }
                        if(powt>=2)
                        {
                            printf("Forbidden: monopoly.\n");
                            break;
                        }
                        powt=0;
                        pos=-1;
                        for(unsigned int k=0; k<conected[to].size();k++)
                        {
                            if(conected[to][k].own==ow)
                                powt++;
                            if(conected[to][k].to==fr)
                                pos=k;
                        }
                        if(powt>=2)
                        {
                            printf("Forbidden: monopoly.\n");
                            break;
                        }
                        conected[fr][j].own=ow;
                        conected[to][pos].own=ow;
                        printf("Sold.\n");
                    }
                    break;
                }
            }
            if(find==false)
                printf("No such cable.\n");
        }
        printf("\n");
    }
    
    return 0;
}

